# coding: utf-8

from tkinter import *
from tkinter import ttk
from tkinter import messagebox
from tkinter import filedialog
from scp import SCPClient, SCPException
import traceback
import paramiko
import sys
import os
import shutil
import json
import socket

class GUI_Main:
    def __init__(self, master):
        self.Hosts = []
        self.HStatus = []
        master.minsize(width=800, height=600)
        master.maxsize(width=800, height=600)
        master.option_add('*tearOff', False)
        master.title('Multi Elevator')
        
        menubar = Menu(master)
        master.config(menu = menubar)
        file = Menu(menubar)
        menubar.add_cascade(menu = file, label = "File")
        file.add_command(label = "Reset", command = self.Resetall)
        file.add_separator()
        file.add_command(label = "Import IP addresses", command = self.ImportIP)
        file.add_separator()
        file.add_command(label = "Exit", command = OnExit)
        
        self.frame2  = Frame(master, bg="blue")
        self.frame2.grid(row=0,column=0, rowspan = 2, columnspan =2, sticky = W+E+N+S)
        self.frame2.config(relief = RIDGE)
        for r in range(30):
            master.rowconfigure(r, weight=1)    
        for c in range(20):
            master.columnconfigure(c, weight=1)
        self.Elevatebutton = ttk.Button(self.frame2, text = 'Elevate', command = self.Elevate)
        self.Elevatebutton.grid(row = 0, column = 0, padx = 5, pady = 5, sticky = W+E+N+S)
        self.frame3  = Frame(master, bg="blue")
        self.frame3.grid(row=0,column=2, columnspan =18, sticky = W+E+N+S)
        self.LabelUserName = ttk.Label(self.frame3, text = "User Name")
        self.LabelUserName.grid(row = 0, column = 0, padx = 5, pady = 5, sticky = W+E+N+S)
        self.EntryUSNA = ttk.Entry(self.frame3, width = 20)
        self.EntryUSNA.grid(row = 1, column = 0, padx = 5, pady = 0, sticky = W+E+N+S)
        self.LabelUserPassword = ttk.Label(self.frame3, text = "User Password")
        self.LabelUserPassword.grid(row = 0, column = 1, padx = 5, pady = 5, sticky = W+E+N+S)
        self.EntryUSPW = ttk.Entry(self.frame3, width = 20)
        self.EntryUSPW.grid(row = 1, column = 1, padx = 5, pady = 0, sticky = W+E+N+S)
        self.LabelFirmwareVer = ttk.Label(self.frame3, text = "Firmware Version")
        self.LabelFirmwareVer.grid(row = 0, column = 5, padx = 5, pady = 5, sticky = W+E+N+S)
        self.EntryFWVR = ttk.Entry(self.frame3, width = 20)
        self.EntryFWVR.grid(row = 1, column = 5, padx = 5, pady = 0, sticky = W+E+N+S)
        self.ButtonFWFI = ttk.Button(self.frame3, text = 'Firmware File', command = self.AddFirmwareFile)
        self.ButtonFWFI.grid(row = 0, column = 3, padx = 5, pady = 5, sticky = W+E+N+S)
        self.EntryFWFI = ttk.Entry(self.frame3, width = 30)
        self.EntryFWFI.grid(row = 1, column = 3, padx = 5, pady = 0, sticky = W+E+N+S)
        self.frame4  = Frame(master, bg="blue")
        self.frame4.grid(row=1,column=2, columnspan =18, sticky = W+E+N+S)
        self.ButtonNWIP = ttk.Button(self.frame4, text = 'Add IP Address', command = self.AddIPButton)
        self.ButtonNWIP.grid(row = 0, column = 0, padx = 5, pady = 5, sticky = W+E+N+S)
        self.EntryNWIP = ttk.Entry(self.frame4, width = 20)
        self.EntryNWIP.grid(row = 1, column = 0, padx = 5, pady = 0, sticky = W+E+N+S)
        self.ButtonJSFI = ttk.Button(self.frame4, text = 'JSON File', command = self.AddJSONFile)
        self.ButtonJSFI.grid(row = 0, column = 1, padx = 5, pady = 5, sticky = W+E+N+S)
        self.EntryJSFI = ttk.Entry(self.frame4, width = 30)
        self.EntryJSFI.grid(row = 1, column = 1, padx = 5, pady = 0, sticky = W+E+N+S)
        self.ButtonPWFI = ttk.Button(self.frame4, text = 'Password File', command = self.AddPasswordFile)
        self.ButtonPWFI.grid(row = 0, column = 2, padx = 5, pady = 5, sticky = W+E+N+S)
        self.EntryPWFI = ttk.Entry(self.frame4, width = 30)
        self.EntryPWFI.grid(row = 1, column = 2, padx = 5, pady = 0, sticky = W+E+N+S)
        self.CheckButtonCHIPValue = IntVar()
        self.CheckButtonCHIP = ttk.Checkbutton(self.frame4, text = 'Change IP address in JSON', variable = self.CheckButtonCHIPValue)
        self.CheckButtonCHIP.grid(row = 0, column = 3, padx = 5, pady = 5, sticky = W+E+N+S)
        self.CheckButtonCHIPValue.set(True)
        self.frame5 = Frame(master, bg="blue")
        self.frame5.grid(row=2,column=0, rowspan = 25, columnspan =16, sticky = W+E+N+S)
        self.treeview = ttk.Treeview(self.frame5)
        self.treeview.grid(row = 0, column = 0, padx = 5, pady = 5, sticky = NSEW)
        self.treeview.config(height = 22, selectmode = "extended")
        self.treeview.heading('#0', text = 'IP ADDRESSES')
        self.treeview.column('#0', minwidth = 600, width = 600)
        self.scrollbartree = Scrollbar(self.frame5)
        self.scrollbartree.grid(row = 0, column = 1, sticky = 'nse')
        self.scrollbartree.config(command = self.treeview.yview)
        self.treeview.config(yscrollcommand = self.scrollbartree.set)
        self.frame6 = Frame(master, bg="blue")
        self.frame6.grid(row=2,column=16, rowspan = 25, columnspan =6, sticky = W+E+N+S)

        
    def validIP(self, address):
        # Subroutine to test if the IP address is valid
        try:
            parts = address.split(".")
            if len(parts) != 4:
                return False
            for item in parts:
                if not 0 <= int(item) <= 255:
                    return False
            return True
    
        except ValueError:
            return False

    def Fileaddress(self, fileaddre):
        #subroutine to extract IP address from IP file to variable and remove blank lines.
        self.Hosts = []
        self.HStatus = []
        f = open(fileaddre)
        for line in f:
            if self.validIP(line):
                linestp = line.strip('\n')
                self.Hosts.append(linestp)
                self.HStatus.append("added")
        f.close()
        return
    
    def DisplayHoststree(self):
        for ia in self.treeview.get_children():
            self.treeview.delete(ia)
        for ii, cc in enumerate(self.Hosts):
            self.treeview.insert('',ii , ('IP{}'.format(ii)), text = ('{}  status = {}'.format(self.Hosts[ii], self.HStatus[ii])))
        self.frame5.update()
        return
        
    def Elevate(self):
        self.DisableNormalGUI(DISABLED)
        for jj, dd in enumerate(self.Hosts):
            if self.Hosts != []:
                self.Write2Unit(jj)
        self.DisableNormalGUI(NORMAL)
                            
    def Write2Unit(self, HostNumber):
        
        self.HStatus[HostNumber] = ("Connecting to {} with Username:- {} and Password:- {}".format(self.Hosts[HostNumber], self.EntryUSNA.get(), self.EntryUSPW.get()))
        self.DisplayHoststree()
          
        #Comment -Open ssh connection to unit
        client = paramiko.SSHClient()
        client.set_missing_host_key_policy(paramiko.AutoAddPolicy())
        
        try:
            client.connect(
                hostname=self.Hosts[HostNumber], username=self.EntryUSNA.get(),
                password=self.EntryUSPW.get(), port=22, timeout=2
            )
        except paramiko.AuthenticationException:
            tb = traceback.format_exc()
            self.HStatus[HostNumber] = ('Wrong User Name or Password')
            self.DisplayHoststree()
            return
        except paramiko.SSHException:
            tb = traceback.format_exc()
            self.HStatus[HostNumber] = ('Connection Failed')
            self.DisplayHoststree()
            return
        except paramiko.BadHostKeyException:
            tb = traceback.format_exc()
            self.HStatus[HostNumber] = ('Bad host name')
            self.DisplayHoststree()
            return
        except socket.error:
            tb = traceback.format_exc()
            self.HStatus[HostNumber] = ('Connection/Socket Timed out')
            self.DisplayHoststree()
            return   
            
        # #Comment - Copy JSON file  to "/etc/persistent/.configured_3.3" on the device
        #Make JSON File
        if  self.CheckButtonCHIPValue.get() and self.EntryJSFI.get():
            self.CopyJson(HostNumber)
            self.AddAddress2JSON(HostNumber)
            
        scp = SCPClient(client.get_transport())
        conf_name = ".configured_{}".format(self.EntryFWVR.get())
        if  self.CheckButtonCHIPValue.get():
            conf_file = ("{}_tmp.json".format(self.Hosts[HostNumber]))
        else:
            conf_file = (self.EntryJSFI.get())
        pass_file = (self.EntryPWFI.get())
        try:
            stdin, stdout, stderr = client.exec_command("mkdir -p /etc/persistent/mnt/config/")
    
            if self.EntryJSFI.get():
                scp.put(conf_file, "/etc/persistent/mnt/config/{}" .format(conf_name))
                self.HStatus[HostNumber] = ('configiguration file copied')
                self.DisplayHoststree()
            
            if self.EntryPWFI.get():
                scp.put((self.EntryPWFI.get()), "/etc/persistent/mnt/config/passwd")
                self.HStatus[HostNumber] = ('Password file copied')
                self.DisplayHoststree()
             
            stdin, stdout, stderr = client.exec_command("cfgmtd -w -f /tmp/running.cfg -p /etc/")     
        
            self.HStatus[HostNumber] = ('Coping configuration to unit')
            self.DisplayHoststree()
            for line in stderr:
                print(line)
            self.HStatus[HostNumber] = ('Configuration copied to unit')
            self.DisplayHoststree()
        
            if self.EntryFWFI.get():
                scp.put(self.EntryFWFI.get(), "/tmp/fwupdate.bin")
                self.HStatus[HostNumber] = ('Firmware copied')
                self.DisplayHoststree()
                stdin, stdout, stderr = client.exec_command("/usr/bin/fwupdate -m /tmp/fwupdate.bin")
                self.HStatus[HostNumber] = ('Firmware update started')
                self.DisplayHoststree()
        
        except (SCPException,paramiko.SSHException)  as error:
            tb = traceback.format_exc()
            self.HStatus[HostNumber] = ('Error loading files')
            self.DisplayHoststree()
            print('error')
            return
        
        client.close()
           
        self.HStatus[HostNumber] = ("Elevation completed")
        self.DisplayHoststree()
        
    def Resetall(self):
        self.Hosts = []
        self.HStatus = []
        for ia in self.treeview.get_children():
            self.treeview.delete(ia)
        self.CheckButtonCHIPValue.set(True)
        self.EntryNWIP.delete(0, END)
        self.EntryFWFI.delete(0, END)
        self.EntryUSNA.delete(0, END)
        self.EntryUSPW.delete(0, END)
        self.EntryFWVR.delete(0, END)
        self.EntryJSFI.delete(0, END)
        self.EntryPWFI.delete(0, END)
        
        
    def AddIPButton(self):
        if self.validIP(self.EntryNWIP.get()):
            self.Hosts.append(self.EntryNWIP.get())
            self.HStatus.append("added")
            self.DisplayHoststree()
        
    def AddFirmwareFile(self):
        self.ImportFWFI = filedialog.askopenfile()
        print(self.ImportFWFI.name)
        self.EntryFWFI.delete(0, END)
        self.EntryFWFI.insert(0, self.ImportFWFI.name)
        self.EntryFWFI.focus()
        self.frame2.update()
        self.EntryFWFI.xview(END)
    
    def AddJSONFile(self):
        self.ImportFWFI = filedialog.askopenfile()
        print(self.ImportFWFI.name)
        self.EntryJSFI.delete(0, END)
        self.EntryJSFI.insert(0, self.ImportFWFI.name)
        self.EntryJSFI.focus()
        self.frame3.update()
        self.EntryJSFI.xview(END)
        
    def AddPasswordFile(self):
        self.ImportFWFI = filedialog.askopenfile()
        print(self.ImportFWFI.name)
        self.EntryPWFI.delete(0, END)
        self.EntryPWFI.insert(0, self.ImportFWFI.name)
        self.EntryPWFI.focus()
        self.frame3.update()
        self.EntryPWFI.xview(END)       
                
    def ImportIP(self):
        self.ImportIPFINA = filedialog.askopenfile()

        if self.ImportIPFINA:
            try:
                print(self.ImportIPFINA.name)
                self.Fileaddress(self.ImportIPFINA.name)
                self.DisplayHoststree()
            except IOError as e:
                print ("I/O error({0}): {1}".format(e.errno, e.strerror))
                messagebox.showinfo(title = 'File Error', message = 'Reading File Error')
            except:
                print ("Unexpected error:", sys.exc_info()[0])
                messagebox.showinfo(title = 'File Error', message = 'Reading File Error')
            return
        if self.ImportIPFINA:
            print(self.ImportIPFINA)
        else:
            print("nothing")
          
    def DisableNormalGUI(self,State1):
        self.CheckButtonCHIP.config(state=State1)
        self.EntryNWIP.config(state=State1)
        self.EntryFWFI.config(state=State1)
        self.EntryUSNA.config(state=State1)
        self.EntryUSPW.config(state=State1)
        self.EntryFWVR.config(state=State1)
        self.EntryJSFI.config(state=State1)
        self.EntryPWFI.config(state=State1)
        self.ButtonFWFI.config(state=State1)
        self.ButtonNWIP.config(state=State1)
        self.ButtonJSFI.config(state=State1)
        self.ButtonPWFI.config(state=State1) 
        
        
        
        
    def CopyJson(self, steppp):
        #subroutine to make a temporay copy of json file to edit IP address for each unit 
        try:
            shutil.copy2((self.EntryJSFI.get()), ("{}_tmp.json".format(self.Hosts[steppp]))) # File Copy
        except IOError as e:
            print ("I/O error({0}): {1}".format(e.errno, e.strerror))
            sys.exit()
        except:
            print ("Unexpected error:", sys.exc_info()[0])
            sys.exit()
    
    def delJson(self): 
        #subroutine to make a delete copy of json file  
        try:
            os.remove("tmp.json")
        except IOError as e:
            print ("I/O error({0}): {1}".format(e.errno, e.strerror))
        except:
            print ("Unexpected error:", sys.exc_info()[0])
           
    def AddAddress2JSON(self, stepppp):
        #subroutine to add ip address of each unit to json file.
        try:
            with open("{}_tmp.json".format(self.Hosts[stepppp]), "r+") as jsonFile:
                data = json.load(jsonFile)
            
            ## Working with buffered content
                data["network"]["mode"]["bridge_ipaddr"]  = (self.Hosts[stepppp])      
            
            ## Save our changes to JSON file
                jsonFile.seek(0)  # rewind
                json.dump(data, jsonFile)
                jsonFile.truncate()
                jsonFile.close()
        
        except IOError as e:
            print ("I/O error({0}): {1}".format(e.errno, e.strerror))
        except KeyError as e:
            print ("Key not there")
        except:
            print ("Unexpected error:", sys.exc_info()[0])
      
        

def OnExit():
    quit()            

def main():
    print("Main")
    root = Tk()
    GUI_main = GUI_Main(root)
    root.mainloop()
    
if __name__ == "__main__": main()